# This program provides Ruby shims for the HTTP calls
# to the Buddy Platform
#
# More info on the requirements for each method can be found at http://buddy.com/documentation.aspx
#
# Author:: Liam Mycroft
# Copyright:: Copyright (c) 2013 Liam Mycroft, a Human
# License:: MIT

require 'yaml'

# This program provides Ruby shims for the HTTP calls
# to the Buddy Platform
module BuddyLiamog

  # Configuration Holder
  @config = {
      :applicationName =>  '',
      :applicationPass => ''
  }

  @valid_config_keys = @config.keys

  # Blank configuration
  def self.config
    @config
  end

  # Set the application config settings
  def self.set_config(application_name, application_pass)
    @config[:applicationName] = application_name
    @config[:applicationPass] = application_pass
  end

  # Create a user account
  def self.useraccount_profile_create(new_username, user_supplied_password, new_user_gender, user_age, new_user_email, status_id)
    require 'net/https'
    #https://webservice.buddyplatform.com/Service/v1/BuddyService.ashx?
    # UserAccount_Profile_Create
    # &BuddyApplicationName=EII_Application
    # &BuddyApplicationPassword=2D5A783F-1CA2-4464-8EF0-4C0AB5279410
    # &NewUserName=BuddyTester3
    # &UserSuppliedPassword=testerpw3
    # &NewUserGender=male
    # &UserAge=21
    # &NewUserEmail=tester2@test.com
    # &StatusID=1
    # &FuzzLocationEnabled=1
    # &CelebModeEnabled=1
    # &ApplicationTag=&RESERVED=
    uri = URI.parse(URI.escape('https://webservice.buddyplatform.com/Service/v1/BuddyService.ashx?UserAccount_Profile_Create&BuddyApplicationName='+@config[:applicationName]+'&BuddyApplicationPassword='+@config[:applicationPass]+'&NewUserName='+new_username+'&UserSuppliedPassword='+user_supplied_password+'&NewUserGender='+new_user_gender+'&UserAge='+user_age+'&NewUserEmail='+new_user_email+'&StatusID='+status_id+'&ApplicationTag=&RESERVED='))
    http = Net::HTTP.new(uri.host, uri.port)
    http.use_ssl = true
    http.verify_mode = OpenSSL::SSL::VERIFY_NONE
    request = Net::HTTP::Get.new(uri.request_uri)
    response = http.request(request)
    return response.body
  end

  # Send a message from user token to user_id
  def self.messages_message_send(user_token, message_string, to_user_id)
    require 'net/https'

    # https://webservice.buddyplatform.com/Service/v1/BuddyService.ashx?
    # Messages_Message_Send
    # &BuddyApplicationName=<appName>
    # &BuddyApplicationPassword=<appPassword>
    # &UserToken=<userToken>
    # &MessageString=<messageString>
    # &ToUserID=<toUserID>
    # &ApplicationTag=<applicationTag>   OPTIONAL
    # &RESERVED=                         OPTIONAL

    uri = URI.parse(URI.escape('https://webservice.buddyplatform.com/Service/v1/BuddyService.ashx?Messages_Message_Send&BuddyApplicationName='+@config[:applicationName]+'&BuddyApplicationPassword='+@config[:applicationPass]+'&UserToken='+user_token+'&MessageString='+message_string+'&ToUserID='+to_user_id.to_s))
    http = Net::HTTP.new(uri.host, uri.port)
    http.use_ssl = true
    http.verify_mode = OpenSSL::SSL::VERIFY_NONE
    request = Net::HTTP::Get.new(uri.request_uri)
    response = http.request(request)
    return response.body
  end

  # Get messages for user with user_token
  def self.messages_message_get(user_token)
    require 'net/https'
    uri = URI.parse(URI.escape('https://webservice.buddyplatform.com/Service/v1/BuddyService.ashx?Messages_Messages_Get&BuddyApplicationName='+@config[:applicationName]+'&BuddyApplicationPassword='+@config[:applicationPass]+'&UserToken='+user_token))
    http = Net::HTTP.new(uri.host, uri.port)
    http.use_ssl = true
    http.verify_mode = OpenSSL::SSL::VERIFY_NONE
    request = Net::HTTP::Get.new(uri.request_uri)
    response = http.request(request)
    return response.body
  end

  # Set application level metadata
  def self.metadata_application_meta_data_value_set(socket_meta_key,socket_meta_value, meta_latitude, meta_longitude)
    require 'net/https'
    uri = URI.parse(URI.escape('https://webservice.buddyplatform.com/Service/v1/BuddyService.ashx?MetaData_ApplicationMetaDataValue_Set&BuddyApplicationName='+@config[:applicationName]+'&BuddyApplicationPassword='+@config[:applicationPass]+'&SocketMetaKey='+socket_meta_key+'&SocketMetaValue='+socket_meta_value+'&MetaLatitude='+meta_latitude+'&MetaLongitude='+meta_longitude))
    http = Net::HTTP.new(uri.host, uri.port)
    http.use_ssl = true
    http.verify_mode = OpenSSL::SSL::VERIFY_NONE
    request = Net::HTTP::Get.new(uri.request_uri)
    response = http.request(request)
    return response.body
  end

  # Get application level metadata
  def self.metadata_application_meta_data_value_get(socket_meta_key)
    require 'net/https'
    uri = URI.parse(URI.escape('https://webservice.buddyplatform.com/Service/v1/BuddyService.ashx?MetaData_ApplicationMetaDataValue_Get&BuddyApplicationName='+@config[:applicationName]+'&BuddyApplicationPassword='+@config[:applicationPass]+'&SocketMetaKey='+socket_meta_key))
    http = Net::HTTP.new(uri.host, uri.port)
    http.use_ssl = true
    http.verify_mode = OpenSSL::SSL::VERIFY_NONE   crd
    request = Net::HTTP::Get.new(uri.request_uri)
    response = http.request(request)
    return response.body
  end
end